type token =
  | ID of (Location.t * string)
  | INTEGER of (Location.t * int)
  | REAL of (Location.t * float)
  | STRING of (Location.t * string)
  | CHARACTER of (Location.t * char)
  | TRUE of (Location.t)
  | FALSE of (Location.t)
  | NULL of (Location.t)
  | THIS of (Location.t)
  | NEW of (Location.t)
  | SUPER of (Location.t)
  | ABSTRACT
  | BOOLEAN
  | BREAK
  | BYTE
  | BYVALUE
  | CASE
  | CAST
  | CATCH
  | CHAR
  | CLASS
  | CONST
  | CONTINUE
  | DEFAULT
  | DO
  | DOUBLE
  | ELSE
  | EXTENDS
  | FINAL
  | FINALLY
  | FLOAT
  | FOR
  | FUTURE
  | GENERIC
  | GOTO
  | IF
  | IMPLEMENTS
  | IMPORT
  | INNER
  | INSTANCEOF
  | INT
  | INTERFACE
  | LONG
  | NATIVE
  | OPERATOR
  | OUTER
  | PACKAGE
  | PRIVATE
  | PROTECTED
  | PUBLIC
  | REST
  | RETURN
  | SHORT
  | STATIC
  | SWITCH
  | SYNCHRONIZED
  | THROW
  | THROWS
  | TRANSIENT
  | TRY
  | VAR
  | VOID
  | VOLATILE
  | WHILE
  | LEFTPAR of (Location.t)
  | RIGHTPAR
  | LEFTBRACE
  | RIGHTBRACE
  | LEFTBRACKET
  | RIGHTBRACKET
  | SEMICOLON
  | COLON
  | COMMA
  | QUESTIONMARK
  | DOT
  | DOC_COMMENT of (string)
  | JML_DECLARATIONS of (Ast_types.jml_declaration list)
  | JML_METHOD_SPECIFICATION of (Ast_types.method_specification)
  | JML_LOOP_ANNOTATION of (Ast_types.loop_annotation)
  | JML_STATEMENT_SPECIFICATION of (Ast_types.statement_specification)
  | JML_ASSERTION of (Ast_types.expr)
  | JML_PURE
  | JML_SPEC_PUBLIC
  | EOF
  | ASSIGNOP of (string)
  | EQ
  | VERTICALBARVERTICALBAR
  | AMPERSANDAMPERSAND
  | VERTICALBAR
  | CARET
  | AMPERSAND
  | EQOP of (string)
  | COMP of (string)
  | SHIFT of (string)
  | PLUS of (Location.t)
  | MINUS of (Location.t)
  | STAR
  | SLASH
  | PERCENT
  | PLUSPLUS of (Location.t)
  | MINUSMINUS of (Location.t)
  | TILDA of (Location.t)
  | BANG of (Location.t)

val compilation_unit :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast_types.compilation_unit
