type token =
  | ID of (Location.t * string)
  | INTEGER of (Location.t * int)
  | REAL of (Location.t * float)
  | STRING of (Location.t * string)
  | CHARACTER of (Location.t * char)
  | TRUE of (Location.t)
  | FALSE of (Location.t)
  | NULL of (Location.t)
  | THIS of (Location.t)
  | BSRESULT of (Location.t)
  | NEW of (Location.t)
  | SUPER of (Location.t)
  | BSOLD of (Location.t)
  | BSFRESH of (Location.t)
  | ASSERT
  | INVARIANT
  | LOOP_INVARIANT
  | BEHAVIOR
  | NORMAL_BEHAVIOR
  | EXCEPTIONAL_BEHAVIOR
  | ALSO
  | AND
  | FORALL
  | OLD
  | MODEL
  | GHOST
  | REQUIRES
  | WHEN
  | MEASURED_BY
  | SIGNALS
  | DECREASES
  | ENSURES
  | ASSIGNABLE
  | IF
  | DIVERGES
  | BSEVERYTHING
  | BSNOTHING
  | BSFIELDSOF
  | BSFORALL
  | BSEXISTS
  | PROTECTED
  | PRIVATE
  | PUBLIC
  | PURE
  | SPEC_PUBLIC
  | FINAL
  | STATIC
  | INSTANCEOF
  | SHORT
  | BOOLEAN
  | BYTE
  | CHAR
  | INT
  | FLOAT
  | LONG
  | DOUBLE
  | REPRESENTS
  | LEFTPAR of (Location.t)
  | RIGHTPAR
  | LEFTBRACE
  | RIGHTBRACE
  | LEFTBRACKET
  | RIGHTBRACKET
  | LEFTBRACEBAR
  | BARRIGHTBRACE
  | SEMICOLON
  | COLON
  | COMMA
  | QUESTIONMARK
  | DOT
  | DOTDOT
  | LEFTARROW
  | EOF
  | ASSIGNOP of (string)
  | EQ
  | LTEQEQGT
  | LTEQBANGEQGT
  | EQEQGT
  | LTEQEQ
  | VERTICALBARVERTICALBAR
  | AMPERSANDAMPERSAND
  | VERTICALBAR
  | CARET
  | AMPERSAND
  | EQOP of (string)
  | COMP of (string)
  | SHIFT of (string)
  | PLUS of (Location.t)
  | MINUS of (Location.t)
  | STAR
  | SLASH
  | PERCENT
  | PLUSPLUS of (Location.t)
  | MINUSMINUS of (Location.t)
  | TILDA of (Location.t)
  | BANG of (Location.t)

val jml_specification_eof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast_types.jml_specification
